# -*- coding: utf-8 -*-

# __init__.py

import rb
import gobject
import gtk
import rhythmdb
from google import GoogleMusic
import google

class Plugin(rb.Plugin):
	def __init__(self):
		rb.Plugin.__init__(self)
        def activate(self, shell):
		self.db = shell.props.db

		self.entry_type = self.db.entry_register_type("OnlineMusicType")
		self.entry_type.get_playback_uri=self.get_playback_uri
		
		width, height = gtk.icon_size_lookup(gtk.ICON_SIZE_LARGE_TOOLBAR)
		icon = gtk.gdk.pixbuf_new_from_file_at_size(self.find_file("32.png"), width, height)

		self.source = gobject.new (OnlineMusicSource, shell=shell, name=_("Online Muisc"),plugin=self,icon=icon, entry_type=self.entry_type)
		shell.append_source(self.source, None)
		shell.register_entry_type_for_source(self.source, self.entry_type)


                # First lets see if we can add to the context menu
                ui = shell.get_ui_manager()

                # Group and it's actions
                self.action_group = gtk.ActionGroup ('TestActions')

                # Create Actions for the plugin
                action = gtk.Action ('PrePage', _('Previous page'),
                                     _('Previous page'),
                                     'gtk-go-back')
                activate_id = action.connect ('activate', lambda a: self.source.onlineMusic.prePage())#self.source.onlineMusic.activate()
		self.action_group.add_action (action)




                # Create Actions for the plugin
                action = gtk.Action ('NextPage', _('Next page'),
                                     _('Next page1'),
                                     'gtk-go-forward')
                activate_id = action.connect ('activate', lambda a: self.source.onlineMusic.nextPage())
		self.action_group.add_action (action)

                # Create Actions for the plugin
		# fangkailove@yeah.net add begin
                action = gtk.Action ('EaSongs', _('欧美热歌'),
                                     _('欧美热歌'),
                                     'gtk-jump-to')
                activate_id = action.connect ('activate', lambda a: self.source.onlineMusic.setGrouping('ea_songs_cn'))
		self.action_group.add_action (action)

                action = gtk.Action ('ChSongs', _('华语热歌'),
                                     _('华语热歌'),
                                     'gtk-jump-to')
                activate_id = action.connect ('activate', lambda a: self.source.onlineMusic.setGrouping('chinese_songs_cn'))
		self.action_group.add_action (action)

                action = gtk.Action ('RkSongs', _('摇滚热歌'),
                                     _('摇滚热歌'),
                                     'gtk-jump-to')
                activate_id = action.connect ('activate', lambda a: self.source.onlineMusic.setGrouping('rock_songs_cn'))

		self.action_group.add_action (action)
 




		# fangkailove@yeah.net add end

                ui.insert_action_group(self.action_group, -1)

        def deactivate(self, shell):
		self.db.entry_delete_by_type(self.entry_type)
		self.db.commit()
		self.db = None
		self.entry_type = None

		self.source.delete_thyself()
		self.source = None
		self.onlineMusic=None
	def get_playback_uri(self,entry):
		if not entry:return None
		url=self.db.entry_get (entry, rhythmdb.PROP_LOCATION)
		if not url.endswith('.mp3'):
			url=google.getSongUrl(url)
			if url:
				self.db.set(entry, rhythmdb.PROP_LOCATION, url)
			else:
				return None
		return url
class OnlineMusicSource(rb.BrowserSource):
	def __init__(self):
		rb.BrowserSource.__init__(self)
		self.__activated=False
		self.onlineMusic=None
		self.__progressing=False
	def do_impl_activate(self):
		if not self.__activated:
			print 'do something init:'
			self.__activated=True
			self.shell=self.get_property('shell')
			self.db = self.shell.get_property('db')
			self.entry_type = self.get_property('entry-type')
			self.onlineMusic=GoogleMusic(self)
			self.onlineMusic.activate()
			player=self.shell.get_player().get_property('player')
			#player.connect("eos",self.eos,self.shell.get_player())
			player.connect("buffering",self.eos,self.shell.get_player())

			#player.connect("playing-song-changed",self.entry_activated)#playing_song_changed)
			#player.connect("playing-changed",self.playing_changed)
			#self.get_entry_view().connect("entry-activated",self.entry_activated)
		rb.BrowserSource.do_impl_activate (self)
	def do_impl_get_ui_actions(self):
		return ["PrePage","NextPage","EaSongs","ChSongs","RkSongs"]
	def do_impl_get_status(self):
		if self.__progressing:
			return (_("Loading songs"), None, -1.0)
		else:
			#qm = self.get_property("query-model")
			#return (qm.compute_status_normal("%d song", "%d songs"), None, 0.0)
			return (_("Done"), None, 1.0)
	def eos(self,player,stream_data,progress,shellplayer):
		print "@@@@@@@@@:",type(stream_data)
		#print shellplayer.get_playing_entry ()
		out = open('/home/kanglog/Music/x.mp3', 'w')
		out.write(str(stream_data))
		out.close()
	def notify_progress(self,progressing):
		self.__progressing=progressing
		self.notify_status_changed()
gobject.type_register(OnlineMusicSource)
