import rhythmdb
import rb

import re
import hashlib
def decode(html):
	codeReg=re.compile('&#[\d]+;')
	ite=codeReg.finditer(html)
	res=""
	n=0
	for e in ite:
		res+=html[n:e.start()]
		n=e.end()
		words=e.group()
		res+=unichr(int(words[2:len(words)-1]))
	res+=html[n:]
	return res
def getSongUrl(xmlurl):
	req = Request(xmlurl)
	try:
		response = urlopen(req)
	except URLError, e:
		print 'error'
	else:
		xmlback=response.read()
		#print xmlback
		dom1=parseString(xmlback)
		url=dom1.getElementsByTagName('songUrl')[0].childNodes[0].nodeValue
		lyric=dom1.getElementsByTagName('lyricsUrl')[0].childNodes[0].nodeValue
		return url
	return None
class OnlineMusic():
	def activate(self):pass
	def __init__(self,source):
		self.db=source.db
		self.entry_type=source.entry_type
		self.source=source
		self.songPage=range(0,8)
		self.page=0
		self.default_grouping = 'chinese_songs_cn'
	def add_song(self,song):
		entry = self.db.entry_new(self.entry_type, song['url'])
		self.db.set(entry, rhythmdb.PROP_ARTIST, song['artist'])
		self.db.set(entry, rhythmdb.PROP_TITLE, song['name'])
	def nextPage(self):
		if self.page<7:self.page+=1
		self.activate()
	def prePage(self):
		if self.page>=1:self.page-=1
		self.activate()	
	def setGrouping(self,grp):pass

	'''	
	def activate(self):
		songs=self.getList()
		for song in songs:
			self.add_song(song)
		self.db.commit()
	'''
from urllib2 import Request, urlopen, URLError
import urllib2
from xml.dom.minidom import parse, parseString
class GoogleMusic(OnlineMusic):
	GOOGLE_PLAYER_KEY = "ecb5abdc586962a6521ffb54d9d731a0";#ecb5abdc586962a6521ffb54d9d731a0Sdddbf809708207e6
	def __init__(self,source):
		OnlineMusic.__init__(self,source)
	def parseSongList(self,html):
		#html=re.sub('<[/]*b>', '', html)#<td class=\"%s[ BottomBorder]*\">[\n]*<a[^>]*>[^<]*
		titleReg= re.compile("<td class=\"Title BottomBorder\"><a[^>]*>[^<]*")
		artistReg= re.compile("<td class=\"Artist BottomBorder\">\n<a[^>]*>[^<]*")
		titles=titleReg.findall(html)
		artists=artistReg.findall(html)
		songs=[]
		for title,artist in zip(titles,artists):
			id=title.split("%3D")[1].split("%")[0]
			name=decode(title.split(">")[2])
			artist=decode(artist.split(">")[2])
			#print 'soundId:',id,"@",'soundName:',name,'artist:',artist
			hash = hashlib.md5(self.GOOGLE_PLAYER_KEY + id).hexdigest()
			url="http://www.google.cn/music/songstreaming?id=" + id + "&output=xml&sig=" + hash
			song={'name':name,'artist':artist,'url':url}
			songs.append(song)
			#self.getSongUrl(song)
		#print songs
		return songs
	'''
	def getList(self):
		req = Request("http://www.google.cn/music/chartlisting?q=chinese_songs_cn&cat=song")
		try:
			response = urlopen(req)
		except URLError, e:
			if hasattr(e, 'reason'):
				print 'We failed to reach a server.'
				print 'Reason: ', e.reason
			elif hasattr(e, 'code'):
				print 'The server couldn\'t fulfill the request.'
				print 'Error code: ', e.code
		else:
			html=response.read()
			return self.parseSongList(html)
		return None
	'''
	def activate(self):
		self.source.notify_progress(True)
		#remove the history
		#if self.songPage[self.page]!=self.page:
		#	self.addSongs(self.songPage[self.page])
		#	return

		#print 'Activate,get page:',page
		http = rb.Loader()
		#url="http://www.google.cn/music/chartlisting?q=chinese_songs_cn&cat=song&start=%d"%(self.page*25)

		#fangkailove@yeah.net add to support muti grouping
		url="http://www.google.cn/music/chartlisting?q="+self.default_grouping+"&cat=song&start=%d"%(self.page*25)

		http.get_url(url, self.loadListBack)

	def loadListBack(self,html):
		songs=self.parseSongList(html)
		self.addSongs(songs)

	def addSongs(self,songs):
		if self.songPage[self.page]==self.page:
			self.songPage[self.page]=songs
		self.db.entry_delete_by_type(self.entry_type)
		for song in songs:
			self.add_song(song)
		self.db.commit()
		self.source.notify_progress(False)

	def setGrouping(self,grp):
		self.default_grouping = grp
		self.page = 1
		self.activate()
